/*
    CaPriCe Forever - Amstrad CPC 464/664/6128 emulator
    Copyright (C) 2014-2020 by Frédéric Coste

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <vcl.h>
#pragma hdrstop
#include "TCheatActionMouseDown.h"
#if (__BORLANDC__ == 0x551) // Borland C++ Builder 5 Update 1
#include "..\Forms\TFormMain.h"
#else /* __BORLANDC__ */
#include "..\Forms_XE3\TFormMain.h"
#endif /* __BORLANDC__ */

//---------------------------------------------------------------------------

#pragma package(smart_init)


__fastcall TCheatActionMouseDown::TCheatActionMouseDown(AnsiString Command) : TCheatAction()
//
// Constructor
//
{
  int ParamPos = Command.Pos("=");
  int ParamLength = Command.Length() - ParamPos;
  int CommentPos = Command.Pos(";");

  if (CommentPos)
  {
    ParamLength = CommentPos - ParamPos - 1;
  }
  else
  {
    CommentPos = Command.Length();
  }

  if (ParamPos < CommentPos)
  {
    AnsiString Param = Command.SubString(ParamPos+1, ParamLength).Trim();
    int SeparatorPos = Param.Pos(",");

		// X
    AnsiString StringX = Param.SubString(1, SeparatorPos-1).Trim();

    // Y
    Param = Param.SubString(SeparatorPos+1, Param.Length()).Trim();
    SeparatorPos = Param.Pos(",");
		AnsiString StringY = Param.SubString(SeparatorPos+1, Param.Length()).Trim();

    try
    {
			if (StringX.Pos("&") == 1)
      {
				mX = StrToInt("0x" + StringX.SubString(2, StringX.Length()).Trim());
      }
      else
      {
				mX = StringX.ToInt();
      }
    }
    catch(...)
    {
			mX = -1;
		}

		try
		{
			if (StringY.Pos("&") == 1)
			{
				mY = StrToInt("0x" + StringY.SubString(2, StringY.Length()).Trim());
			}
			else
			{
				mY = StringY.ToInt();
			}
		}
		catch(...)
		{
			mY = -1;
		}

		if ( (mY >= 0) && (mY >= 0) )
		{
			mValid = true;
		}
	}
}
//---------------------------------------------------------------------------


__fastcall TCheatActionMouseDown::~TCheatActionMouseDown(void)
//
// Destructor
//
{
}
//---------------------------------------------------------------------------


void __fastcall TCheatActionMouseDown::Execute(tNativeCPC* NativeCPC)
{
  FormMain->SetMouseDown(mX,mY);

  NOT_USED(NativeCPC);
}
//---------------------------------------------------------------------------
